public class Settings { 
    int x;
    int y;
    int flags;
    String locale;

    static final int FAST_SCROLL = 1;
    static final int AUTO_ZOOM = 2;
    static final int ZOOM_IN = 4;
    static final int BLINKING= 8;

    byte[] pack() { 
        byte[] record = new byte[14];
        Converter.packInt(record, 0, x);
        Converter.packInt(record, 4, y);
        Converter.packInt(record, 8, flags);
        record[12] = (byte)locale.charAt(0);
        record[13] = (byte)locale.charAt(1);
        return record;
    }

    Settings(byte[] record) { 
        x = Converter.unpackInt(record, 0);
        y = Converter.unpackInt(record, 4);
        flags = Converter.unpackInt(record, 8);
        char[] chars = new char[2];
        chars[0] = (char)record[12];
        chars[1] = (char)record[13];
        locale = new String(chars);
    }

    Settings() {
        flags = AUTO_ZOOM|BLINKING;
        x = BrowserCanvas.INIT_X;
        y = BrowserCanvas.INIT_Y;
        locale = System.getProperty("microedition.locale").substring(0, 2);
    }
}