import javax.microedition.lcdui.*;
import java.util.*;

public class ShowLogoCanvas extends Canvas {
    MapBrowser browser;
    Image   logoImage;
    Timer   logoTimer = new Timer();
    boolean done;
    ShowLogoTask showLogoTask;
    Object       showLogoMonitor = new Object();

    static final int SHOW_LOGO_DELAY = 3*1000;

    ShowLogoCanvas(MapBrowser browser) { 
        this.browser = browser;
        try { 
            logoImage = Image.createImage("/logo.png");
        } catch (Exception e) { 
            System.out.println("Failed to show logo: " + e);
            browser.showMap();
            return;
        }
        showLogoTask = new ShowLogoTask();
        logoTimer.schedule(showLogoTask, SHOW_LOGO_DELAY);
        Display.getDisplay(browser).setCurrent(this);
    }

    protected void paint(Graphics g) {
        g.drawImage(logoImage, 0, 0, Graphics.TOP|Graphics.LEFT);
        return;
    }

    public void keyReleased(int keyCode) {
        synchronized (showLogoMonitor) { 
            if (!done) { 
                done = true;
            } else { 
                return;
            }
        }
        browser.showMap();
    }

    class ShowLogoTask extends TimerTask { 
        public void run() { 
            synchronized (showLogoMonitor) { 
                if (!done) { 
                    done = true;
                } else { 
                    return;
                }
            }
            browser.showMap();
        }
    }
}

